import java.io.File
import java.sql.*
import java.util.*
import java.math.BigDecimal
import com.prodinf.utile.Utils
import java.util.ArrayList
import java.util.HashMap

// pt rev cor v9
boolean ok = false
try {
  ArrayList<String> tNames = new ArrayList<String>()
  ArrayList<String> tNamesFaraFirma = new ArrayList<String>()
  HashMap<String, BigDecimal> ids = new HashMap<String, String>()

  if(context.checkIFTableExists("TOTAL", "ALGSC")) tNames.add("ALGSC");// aici adaugam toate tabelele pentru update secvente
  if(context.checkIFTableExists("TOTAL", "R_CONFIG")) tNames.add("R_CONFIG");
  if(context.checkIFTableExists("TOTAL", "CODINTERN")) tNames.add("CODINTERN");
  if(context.checkIFTableExists("TOTAL", "BAZAIMP")) tNames.add("BAZAIMP");
  if(context.checkIFTableExists("TOTAL", "DATAESTIM")) tNames.add("DATAESTIM");
  if(context.checkIFTableExists("TOTAL", "SARBATORI")) tNames.add("SARBATORI");
  if(context.checkIFTableExists("TOTAL", "TIP_ORE_SUPL")) tNames.add("TIP_ORE_SUPL");
  if(context.checkIFTableExists("TOTAL", "VALID_REV")) tNames.add("VALID_REV");
  if(context.checkIFTableExists("TOTAL", "DEFCOR")) tNames.add("DEFCOR");
  if(context.checkIFTableExists("TOTAL", "PERSFUNCTII")) tNames.add("PERSFUNCTII");
  
  if(context.checkIFTableExists("TOTAL", "R_TAGS")) tNamesFaraFirma.add("R_TAGS");
  if(context.checkIFTableExists("TOTAL", "COR_LEGE")) tNamesFaraFirma.add("COR_LEGE");
  if(context.checkIFTableExists("TOTAL", "DU_N3_OBLIGPL")) tNamesFaraFirma.add("DU_N3_OBLIGPL");

  def SQL_INS = 'INSERT INTO TOTAL.SECVENTE VALUES(?,?,?)'
  def SQL_UPD = 'UPDATE TOTAL.SECVENTE SET ' +
              ' NUMAR = ? ' +
              'WHERE ID_FIRMA = ? ' +
              'AND SECVENTA = ? '

  sql.eachRow('SELECT * from TOTAL.FIRME') { row ->
    ids.clear()
    String cond = ""

    for(int i = 0 ; i < tNames.size() ; i++){
      ids.put(tNames.get(i), null)
      cond += "'" + tNames.get(i) + "'"
      if(i < tNames.size() - 1){
        cond += ", "
      }
    }

    sql.eachRow("SELECT * FROM TOTAL.SECVENTE WHERE ID_FIRMA = ? AND SECVENTA IN (" + cond + ")", [row.id]){rw ->
      ids.put(rw.secventa, rw.numar)
    }

    Set<String> keys = ids.keySet();
    for(String key : keys){
      BigDecimal id = BigDecimal.ONE
      def r = sql.firstRow("SELECT MAX(ID) ID FROM TOTAL." + key + " WHERE ID_FIRMA = ?", [row.id])
      if(r != null && r.id != null){
        id = r.id
        id = id.add(BigDecimal.ONE)
      }
      if(ids.get(key) == null){
		sql.execute(SQL_INS, [key, row.id, id])
      } else {
		sql.execute(SQL_UPD, [id, row.id, key])
      }
    }
  }

  if(!tNamesFaraFirma.isEmpty()){
    ids.clear()
    String cond = ""

    for(int i = 0 ; i < tNamesFaraFirma.size() ; i++){
      ids.put(tNamesFaraFirma.get(i), null)
      cond += "'" + tNamesFaraFirma.get(i) + "'"
      if(i < tNamesFaraFirma.size() - 1){
        cond += ", "
      }
    }

    sql.eachRow("SELECT * FROM TOTAL.SECVENTE WHERE SECVENTA IN (" + cond + ")"){rw ->
      ids.put(rw.secventa, rw.numar)
    }

    Set<String> keys = ids.keySet();
    for(String key : keys){
      BigDecimal id = BigDecimal.ONE
      def r = sql.firstRow("SELECT MAX(ID) ID FROM TOTAL." + key)
      if(r != null && r.id != null){
        id = r.id
        id = id.add(BigDecimal.ONE)
      }
      if(ids.get(key) == null){
        sql.execute(SQL_INS, [key, BigDecimal.ZERO, id])
      } else {
        sql.execute(SQL_UPD, [id, BigDecimal.ZERO, key])
      }
    }
  }
  ok = true
} finally {
  try{
    if(ok){
      connection.commit()
    }
    connection.rollback()
  } catch(Exception e){
  }
}
